Index: src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py	(revision 91ad45cad8ea43830c431bc44f72efb1026fb729)
+++ src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
@@ -177,5 +177,5 @@
             no_params_msg = "Fitting can not be performed.\n" +\
                             "Not all tabs chosen for fitting have parameters selected for fitting."
-            QtWidgets.QMessageBox.question(self,
+            QtWidgets.QMessageBox.warning(self,
                                            'Warning',
                                             no_params_msg,
Index: src/sas/qtgui/Perspectives/Fitting/FittingWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 91ad45cad8ea43830c431bc44f72efb1026fb729)
+++ src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
@@ -1174,4 +1174,5 @@
             msg = "Fitting did not converge!"
             self.communicate.statusBarUpdateSignal.emit(msg)
+            msg += res.mesg
             logging.error(msg)
             return
Index: src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision 7fd20fcaad0240e364298e5839ff98bd609bacb4)
+++ src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>448</width>
-    <height>526</height>
+    <width>568</width>
+    <height>605</height>
    </rect>
   </property>
@@ -452,6 +452,6 @@
        <property name="minimumSize">
         <size>
-         <width>75</width>
-         <height>23</height>
+         <width>93</width>
+         <height>28</height>
         </size>
        </property>
@@ -471,6 +471,6 @@
        <property name="minimumSize">
         <size>
-         <width>75</width>
-         <height>23</height>
+         <width>93</width>
+         <height>28</height>
         </size>
        </property>
@@ -490,6 +490,6 @@
        <property name="minimumSize">
         <size>
-         <width>75</width>
-         <height>23</height>
+         <width>93</width>
+         <height>28</height>
         </size>
        </property>
Index: src/sas/qtgui/Plotting/LinearFit.py
===================================================================
--- src/sas/qtgui/Plotting/LinearFit.py	(revision d6b8a1dfaf6521ae4a9054d5195def2810d6d8bc)
+++ src/sas/qtgui/Plotting/LinearFit.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
@@ -13,4 +13,5 @@
 from sas.qtgui.Plotting import DataTransform
 from sas.qtgui.Plotting.LineModel import LineModel
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
 
 # Local UI
@@ -56,6 +57,9 @@
         self.txtRangeMin.setText(str(max_range[0]))
         self.txtRangeMax.setText(str(max_range[1]))
-        self.txtFitRangeMin.setText(str(fit_range[0]))
-        self.txtFitRangeMax.setText(str(fit_range[1]))
+        # Assure nice display of ranges
+        fr_min = GuiUtils.formatNumber(fit_range[0])
+        fr_max = GuiUtils.formatNumber(fit_range[1])
+        self.txtFitRangeMin.setText(str(fr_min))
+        self.txtFitRangeMax.setText(str(fr_max))
 
         # cast xLabel into html
@@ -113,7 +117,4 @@
         # Set the qmin and qmax in the panel that matches the
         # transformed min and max
-        #value_xmin = X_VAL_DICT[self.xLabel].floatTransform(xmin)
-        #value_xmax = X_VAL_DICT[self.xLabel].floatTransform(xmax)
-
         value_xmin = self.floatInvTransform(xmin)
         value_xmax = self.floatInvTransform(xmax)
Index: src/sas/sascalc/fit/expression.py
===================================================================
--- src/sas/sascalc/fit/expression.py	(revision b3e8629bf18b74f4214d6552e620fcbc4e73a28c)
+++ src/sas/sascalc/fit/expression.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
@@ -210,5 +210,9 @@
 
     #print("Function: "+functiondef)
-    exec (functiondef in globals,locals)
+    # Python 2.7
+    #exec (functiondef in globals,locals)
+    # Python 3.5
+    exec (functiondef, globals, locals)
+
     retfn = locals['eval_expressions']
 
